<?php
header("Access-Control-Allow-Origin: *");

if (!isset($_GET['code'])) {
    echo 'Error: C-- source code not specified.';
    exit();
}

if (!isset($_GET['options'])) {
    echo 'Error: compilation options not specified.';
    exit();
}

$source_code = $_GET['code'];
$compiler_options = $_GET['options'];

$listing_filename = 'tmpdir/src.lst';
$errors_filename = 'tmpdir/src.err';
$src_filename = 'tmpdir/src.c--';
$base_filename = 'tmpdir/src';

function _unlink($f) {if (file_exists($f)) unlink($f);}
_unlink($listing_filename);
_unlink($errors_filename);
_unlink($base_filename);
_unlink($base_filename . '.com');
_unlink($base_filename . '.exe');

file_put_contents($src_filename, $source_code);
$compiler_cmdline = 'wsl ./c-- ' . $compiler_options . ' ' . $src_filename;
$compiler_stdout = shell_exec($compiler_cmdline);
if (!file_exists($listing_filename)) {
    $listing = 'No listing: compilation error';
} else {
    $listing = file_get_contents($listing_filename);
}
$res = array('stdout' => $compiler_stdout, 'listing' => $listing);
echo json_encode($res, JSON_UNESCAPED_SLASHES);
// echo $compiler_cmdline;

?>